String isolateData(String data) {
  data.remove(0, 2); //Remove leading bits
  data.remove((data.length() - 1)); //remove stop bit
  return data;
}

void receiveData() {
  String inputString = "";
  bool stringComplete = false;
  while(displaySerial.available()) {
    char inputChar = (char)displaySerial.read();
    inputString += inputChar;
    if (inputChar == stopBit) {
      formatData(inputString);
      inputString = "";
      stringComplete = true;
    }
  }
}

void formatData(String inputData) {
    //assign inputData to correct spot in readingRecieveArr according to identifier
      debugPrint(inputData);
      activity = false; //reset variable until new data dectected
      if (inputData[0] == startBit) {
      if (inputData.startsWith("?t")) {
        //if (checkDiff(inputData, readingRecieveArr[0])) {
        readingRecieveArr[0] = isolateData(inputData).toInt();
        //}
      }
      if (inputData[1] == 'p') {
        //if (checkDiff(inputData, readingRecieveArr[1])) {
        readingRecieveArr[1] = isolateData(inputData).toInt();
        //}
      }
      if (inputData[1] == 'm') {
        //if (checkDiff(inputData, readingRecieveArr[2])) {
        readingRecieveArr[2] = isolateData(inputData).toInt();
        //}
      }
      if (inputData[1] == 'r') {
        //if (checkDiff(inputData, readingRecieveArr[3])) {
        readingRecieveArr[3] = isolateData(inputData).toInt();
        //}
      }
      if (inputData[1] == 'l') {
        //if (checkDiff(inputData, readingRecieveArr[4])) {
        readingRecieveArr[4] = isolateData(inputData).toInt();
        //}
        
      }
   }
}

bool pwrSv(int sleepTime) { //toggles sleep mode depending on inactive time
    if (timer >= sleepTime) {
      shutdownDisplay();
      return true;
    } else if (timer < sleepTime && activity == false) {
      timer++;
      return false;
    } else {
      timer = 0;
      return false;
    }
}

bool checkDiff(String data, int oldData) { //checks data against old data and returns true if different
  if (data.toInt() != oldData) {
    activity = true; //signal new data present
    timer = 0;
    return true; //return true to signal new data recived
  } else {
    activity = false; //signal only old data present
    return false; //return false if data identical to oldData
  }
}

String checkGesture() { //Check for pre programmed gestures
  int checkCount = 0;
  //Check if Gesture is fist
  if (readingRecieveArr[0] == GESTURE_FIST.THUMB) {
    checkCount++;
  }
    if (readingRecieveArr[1] == GESTURE_FIST.POINTER) {
      checkCount++;
    }
      if (readingRecieveArr[2] == GESTURE_FIST.MIDDLE) {
        checkCount++;
      }
        if (readingRecieveArr[3] == GESTURE_FIST.RING) {
          checkCount++;
        }
          if (readingRecieveArr[4] == GESTURE_FIST.LITTLE) {
            checkCount++;
          } 
            if (checkCount == 5) {
              return "FIST";
            } else {
                checkCount = 0;
            }
    if (readingRecieveArr[0] == GESTURE_OPEN.THUMB) {
      checkCount++;
    }
      if (readingRecieveArr[1] == GESTURE_OPEN.POINTER) {
        checkCount++;
      }
        if (readingRecieveArr[2] == GESTURE_OPEN.MIDDLE) {
          checkCount++;
        }
          if (readingRecieveArr[3] == GESTURE_OPEN.RING) {
            checkCount++;
          }
            if (readingRecieveArr[4] == GESTURE_OPEN.LITTLE) { 
              checkCount++;
            }
              if (checkCount == 5) {
                return "OPEN";
              } else {
                return "NULL";
              }
}
